# Summary

- [Introduction](./introduction.md)
- [Building Crosvm](./building_crosvm/index.md)
  - [On Linux](./building_crosvm/linux.md)
  - [On Windows](./building_crosvm/windows.md)
- [Running Crosvm](./running_crosvm/index.md)
  - [Example Usage](./running_crosvm/example_usage.md)
  - [Advanced Usage](./running_crosvm/advanced_usage.md)
  - [Custom Kernel / Rootfs](./running_crosvm/custom_kernel_rootfs.md)
  - [Options and Configuration Files](./running_crosvm/options.md)
  - [System Requirements](./running_crosvm/requirements.md)
  - [Features](./running_crosvm/features.md)
  - [Programmatic Interaction](./running_crosvm/programmatic_interaction.md)
- [Testing](./testing/index.md)
  - [Fuzzing](./testing/fuzzing.md)
- [Devices](./devices/index.md)
  - [Block](./devices/block.md)
  - [Input](./devices/input.md)
  - [Network](./devices/net.md)
  - [Balloon](./devices/balloon.md)
  - [SCSI (experimental)](./devices/scsi.md)
  - [Fs](./devices/fs.md)
  - [Vsock](./devices/vsock.md)
  - [Pmem](./devices/pmem.md)
  - [USB](./devices/usb.md)
  - [Wayland](./devices/wayland.md)
  - [Video (experimental)](./devices/video.md)
  - [Virtual U2F Passthrough](./devices/virtual_u2f.md)
  - [Vhost-user](./devices/vhost_user.md)
- [Tracing](./tracing.md)
- [Integration](./integration/index.md)
  - [ChromeOS](./integration/chromeos.md)
- [Architecture](./architecture/index.md)
  - [Overview](./architecture/overview.md)
  - [Guest interrupts](./architecture/interrupts.md)
  - [Snapshotting (highly experimental)](./architecture/snapshotting.md)
- [Hypervisors](./hypervisors.md)
- [Contribution Guide](./contributing/index.md)
  - [Contributing to crosvm](./contributing/contributing.md)
  - [Coding Style](./contributing/coding_style.md)
  - [Style Guide for Platform-Specific Code](./contributing/style_guide_platform_specific_code.md)

______________________________________________________________________

- [Onboarding Resources](./onboarding.md)
- [Appendix](./appendix/index.md)
  - [Sandboxing](./appendix/sandboxing.md)
  - [Seccomp](./appendix/seccomp.md)
  - [Memory Layout](./appendix/memory_layout.md)
  - [Minijail](./appendix/minijail.md)
  - [Rutabaga](./appendix/rutabaga_gfx.md)

______________________________________________________________________

[Package Documentation](./package_documentation.md)
